# When rebuilding, you can use --without xxx for x11, SDL, xgl and asm68000
# Default :
# --with x11
# --with SDL
# --with xgl
# --with asm68000

%{!?_with_x11: %{!?_without_x11: %define _with_x11 whatever}}
%{!?_with_SDL: %{!?_without_SDL: %define _with_SDL whatever}}
%{!?_with_xgl: %{!?_without_xgl: %define _with_xgl whatever}}
%{!?_with_asm68000: %{!?_without_asm68000: %define _with_asm68000 whatever}}

Summary: The X Multi Arcade Machine Emulator and extras.
Name: xmame
Version: 0.59.2
Release: fr3
Source: http://x.mame.net/download/xmame-%{version}.tar.bz2
Source10: http://www.mame.net/roms/polyplay.zip
Source11: http://www.mame.net/roms/robby.zip
Source12: http://www.mame.net/roms/gridlee.zip
Source20: http://cheat.retrogames.com/cheat.zip
Source21: http://www.sys2064.com/files/mame/unoff_hsdat7.9.zip
Source22: http://www.sys2064.com/files/mame/history0.58d.zip
Source23: http://www.mameworld.net/mameinfo/download/Mameinfo393.zip
Patch0: xmame-0.57.1-redhat.patch
Patch1: xmame-mamex.patch
Patch2: xmame-0.58.2-glcursor.patch
License: MAME
URL: http://x.mame.net/
Group: Applications/Emulators
BuildRoot: %{_tmppath}/%{name}-root
Requires: %{name}-bin = %{version}
BuildRequires: unzip, esound-devel, XFree86-devel, zlib-devel
%{?_with_asm68000:BuildRequires: nasm >= 0.98}


%description
This the the *nix port of the almost legendary mame. Mame is an arcade
machine emulator, started in 1997 by Nicola Salmoria. It started out as a
series of emulators for individual games. This series of emulators was
combined into a single multi-game emulator.

The main package contains the docs, data files, and three free games so that
you have your X-Mame ready to run in no time! You will still need to pick
a package containing the main xmame binary though, from either the basic
x11 version, the SDL version or the special OpenGL xgl version.


%package x11
Summary: X-Mame arcade game emulator compiled for basic X11 display.
Group: Applications/Emulators
Provides: %{name}-bin = %{version}
Requires: esound, zlib

%description x11
This the the *nix port of the almost legendary mame. Mame is an arcade
machine emulator, started in 1997 by Nicola Salmoria. It started out as a
series of emulators for individual games. This series of emulators was
combined into a single multi-game emulator.

This version has been compiled for X11 display.


%package SDL
Summary: X-Mame arcade game emulator compiled for SDL display.
Group: Applications/Emulators
Provides: %{name}-bin = %{version}
Requires: SDL, esound, zlib, arts
BuildRequires: SDL-devel

%description SDL
This the the *nix port of the almost legendary mame. Mame is an arcade
machine emulator, started in 1997 by Nicola Salmoria. It started out as a
series of emulators for individual games. This series of emulators was
combined into a single multi-game emulator.

This version has been compiled for SDL display.


%package xgl
Summary: X-Mame arcade game emulator compiled for OpenGL display.
Group: Applications/Emulators
Provides: %{name}-bin = %{version}
Requires: esound, zlib, libjpeg
BuildRequires: Mesa-devel, libjpeg-devel

%description xgl
This the the *nix port of the almost legendary mame. Mame is an arcade
machine emulator, started in 1997 by Nicola Salmoria. It started out as a
series of emulators for individual games. This series of emulators was
combined into a single multi-game emulator.

This version has been compiled for OpenGL display.


%prep
%setup -q
%patch0 -p1 -b .redhat
%patch1 -p1 -b .mamex
#%patch2 -p1 -b .glcursor

%build
# Optimization flags
%ifarch i386
export OPT_FLAGS="-O3 -march=i386 -mcpu=i686 -Wall -Wno-unused -pipe -funroll-loops -fstrength-reduce -fomit-frame-pointer -ffast-math -malign-functions=2 -malign-jumps=2 -malign-loops=2 -fstrict-aliasing"
%endif
%ifarch ppc
export OPT_FLAGS="-O -Wall -Wno-unused -funroll-loops -fstrength-reduce -fomit-frame-pointer -ffast-math -fsigned-char"
%endif

# Defaults to be overridden in the Makefile
%ifarch i386
export JOY_I386=1
export SOUND_ESOUND=1
%endif

%{?_with_asm68000: export X86_ASM_68000=1}

# Prepare all the extra .dat files
mkdir datfiles
for file in %{SOURCE20} %{SOURCE21} %{SOURCE22} %{SOURCE23}; do
	unzip -d datfiles/ -o $file
done

# Use our patched makefile
mv -f makefile.unix Makefile || :

# Now, do all the building (this is long!)
%{?_with_x11: make DISPLAY_METHOD=x11 X11_DGA=1}
%{?_with_SDL: make DISPLAY_METHOD=SDL}
%{?_with_xgl: make DISPLAY_METHOD=xgl GLCFLAGS="-D_X11_ -DGLU_VERSION_1_2"}


%install
rm -rf %{buildroot}

make install PREFIX=%{buildroot}%{_prefix}/games \
	MANDIR=%{buildroot}%{_mandir}/man6
make copycab PREFIX=%{buildroot}%{_prefix}/games

mkdir -p %{buildroot}%{_prefix}/games/bin
%{?_with_x11: install -m 755 xmame.x11 %{buildroot}%{_prefix}/games/bin/}
%{?_with_SDL: install -m 755 xmame.SDL %{buildroot}%{_prefix}/games/bin/}
%{?_with_xgl: install -m 755 xmame.xgl %{buildroot}%{_prefix}/games/bin/}

# We don't want all the docs
mkdir -p doc2/html
cp -a doc/{*.html,*.css,img} doc2/html/
cp -a doc/{chan*,dga2.txt,gamelist*,multi*,readme*,xmame-doc.txt,*.dist} doc2/

# Add all directories
mkdir -p %{buildroot}%{_prefix}/games/lib/xmame/{roms,snaps,flyers,cabinets,hi,inp}

# Install the ROMs
install -m 644 %{SOURCE10} %{SOURCE11} %{SOURCE12} \
	%{buildroot}%{_prefix}/games/lib/xmame/roms/

# The extra dat files
install -m 664 datfiles/*.dat %{buildroot}%{_prefix}/games/lib/xmame/

# Bogus, so that the %ghost works with the correct type
mkdir -p %{buildroot}%{_prefix}/bin
ln -s ../games/bin/xmame %{buildroot}%{_prefix}/bin/xmame


%post x11
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :

%postun x11
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :

%post SDL
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :

%postun SDL
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :

%post xgl
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :

%postun xgl
rm -f %{_prefix}/bin/xmame
[ -x %{_prefix}/games/bin/xmame.x11 ] && \
	ln -sf ../games/bin/xmame.x11 %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.SDL ] && \
	ln -sf ../games/bin/xmame.SDL %{_prefix}/bin/xmame || :
[ -x %{_prefix}/games/bin/xmame.xgl ] && \
	ln -sf ../games/bin/xmame.xgl %{_prefix}/bin/xmame || :


%clean
rm -rf %{buildroot}


%files
%defattr(-, root, root)
%doc README doc2/*
%dir %{_prefix}/games/lib/xmame
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/cabinets
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/flyers
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/hi
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/inp
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/roms
%dir %attr(775, root, games) %{_prefix}/games/lib/xmame/snaps
%attr(664, root, games) %{_prefix}/games/lib/xmame/roms/*.zip
%{_prefix}/games/lib/xmame/cab
%{_prefix}/games/lib/xmame/*.dat
%{_mandir}/man6/*

%{?_with_x11:%files x11}
%{?_with_x11:%attr(2755, root, games) %{_prefix}/games/bin/xmame.x11}
%{?_with_x11:%attr(-, root, root) %ghost %verify(not mtime) %{_prefix}/bin/xmame}

%{?_with_SDL:%files SDL}
%{?_with_SDL:%attr(2755, root, games) %{_prefix}/games/bin/xmame.SDL}
%{?_with_SDL:%attr(-, root, root) %ghost %verify(not mtime) %{_prefix}/bin/xmame}

%{?_with_xgl:%files xgl}
%{?_with_xgl:%attr(2755, root, games) %{_prefix}/games/bin/xmame.xgl}
%{?_with_xgl:%attr(-, root, root) %ghost %verify(not mtime) %{_prefix}/bin/xmame}


%changelog
* Fri Apr 19 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Looking quite good now.
- Update to 0.59.2.
- Added %post and %postun scriptlets for the /usr/bin/xmame link.

* Thu Apr 11 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file maturing a bit, still in constant development.

* Sun Jan 13 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file rewrite from scratch.

